//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
bool gbCanMove=false;
int giX=0;
int giY=0;
int giXIndex=0;
int giYIndex=0;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   DoubleBuffered=true;

   bmp1=new Graphics::TBitmap;
   bmp2=new Graphics::TBitmap;
   bmp1->LoadFromFile("back.bmp");
   bmp2->LoadFromFile("fore.bmp");

   Image1->Width=bmp1->Width;
   Image1->Height=bmp1->Height;
   Image1->Left=(ClientWidth-Image1->Width)/2;
   Image1->Top=(ClientHeight-Image1->Height)/2;
   Image1->Stretch=true;
   Image1->Picture->Bitmap->Assign(bmp1);

   Image2->Width=bmp2->Width;
   Image2->Height=bmp2->Height;
   Image2->Left=Image1->Left+Image1->Width+10;
   Image2->Top=Image1->Top;
   Image2->Stretch=true;
   Image2->Picture->Bitmap->Assign(bmp2);
   Image2->Picture->Bitmap->TransparentColor=clWhite;
   Image2->Transparent=true;

   Image3->Width=bmp2->Width;
   Image3->Height=bmp2->Height;
   Image3->Left=0;
   Image3->Top=0;
   Image3->Stretch=true;
   Image3->Canvas->Brush->Color=clWhite;
   Image3->Canvas->FillRect(Rect(0, 0, Image3->Width, Image3->Height));
   Image3->Picture->Bitmap->TransparentColor=clWhite;
   Image3->Transparent=true;

   Image4->Width=bmp2->Width;
   Image4->Height=bmp2->Height;
   Image4->Left=0;
   Image4->Top=0;
   Image4->Stretch=true;
   Image4->Canvas->Brush->Color=clWhite;
   Image4->Canvas->FillRect(Rect(0, 0, Image4->Width, Image4->Height));
   Image4->Picture->Bitmap->TransparentColor=clWhite;
   Image4->Transparent=true;

   Image5->Width=bmp2->Width;
   Image5->Height=bmp2->Height;
   Image5->Left=0;
   Image5->Top=0;
   Image5->Stretch=true;
   Image5->Canvas->Brush->Color=clWhite;
   Image5->Canvas->FillRect(Rect(0, 0, Image5->Width, Image5->Height));
   Image5->Picture->Bitmap->TransparentColor=clWhite;
   Image5->Transparent=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   delete bmp1;
   delete bmp2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image2MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   gbCanMove=true;
   giX=X;
   giY=Y;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image2MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   int iXOffset=X-giX;
   int iYOffset=Y-giY;

   if(gbCanMove)
   {
      giXIndex=2;
      if(Image2->Left+iXOffset<ClientRect.Left)
      {
         Image2->Left=0;
      }
      else if(Image2->Left+Image2->Width+iXOffset>ClientRect.Right)
      {
         Image2->Left=ClientRect.Right-Image2->Width;
      }
      else
      {
         Image2->Left+=iXOffset;
         if((Image2->Left<Image1->Left) &&
            (Image2->Left+Image2->Width>Image1->Left))
         {
            giXIndex=-1;
         }
         else if((Image2->Left<Image1->Left+Image1->Width) &&
            (Image2->Left+Image2->Width>Image1->Left+Image1->Width))
         {
            giXIndex=1;
         }
         else if((Image2->Left>=Image1->Left) &&
            (Image2->Left+Image2->Width<=Image1->Left+Image1->Width))
         {
            giXIndex=0;
         }
         else
         {
            giXIndex=2;
         }
      }

      giYIndex=2;
      if(Image2->Top+iYOffset<ClientRect.Top)
      {
         Image2->Top=0;
      }
      else if(Image2->Top+Image2->Height+iYOffset>ClientRect.Bottom)
      {
         Image2->Top=ClientRect.Bottom-Image2->Height;
      }
      else
      {
         Image2->Top+=iYOffset;
         if((Image2->Top<Image1->Top) &&
            (Image2->Top+Image2->Height>Image1->Top))
         {
            giYIndex=-1;
         }
         else if((Image2->Top<Image1->Top+Image1->Height) &&
            (Image2->Top+Image2->Height>Image1->Top+Image1->Height))
         {
            giYIndex=1;
         }
         else if((Image2->Top>=Image1->Top) &&
            (Image2->Top+Image2->Height<=Image1->Top+Image1->Height))
         {
            giYIndex=0;
         }
         else
         {
            giYIndex=2;
         }
      }

      if(giXIndex==-1 && giYIndex==0)
      {
         Image3->Left=Image2->Left+Image1->Width;
         Image3->Top=Image2->Top;
         Image4->Left=0;
         Image4->Top=0;
         Image5->Left=0;
         Image5->Top=0;
      }
      else if(giXIndex==1 && giYIndex==0)
      {
         Image3->Left=Image2->Left-Image1->Width;
         Image3->Top=Image2->Top;
         Image4->Left=0;
         Image4->Top=0;
         Image5->Left=0;
         Image5->Top=0;
      }
      else if(giXIndex==0 && giYIndex==-1)
      {
         Image3->Left=0;
         Image3->Top=0;
         Image4->Left=Image2->Left;
         Image4->Top=Image2->Top+Image1->Height;
         Image5->Left=0;
         Image5->Top=0;
      }
      else if(giXIndex==0 && giYIndex==1)
      {
         Image3->Left=0;
         Image3->Top=0;
         Image4->Left=Image2->Left;
         Image4->Top=Image2->Top-Image1->Height;
         Image5->Left=0;
         Image5->Top=0;
      }
      else if(giXIndex==-1 && giYIndex==-1)
      {
         Image3->Left=Image2->Left+Image1->Width;
         Image3->Top=Image2->Top;
         Image4->Left=Image2->Left;
         Image4->Top=Image2->Top+Image1->Height;
         Image5->Left=Image2->Left+Image1->Width;
         Image5->Top=Image2->Top+Image1->Height;
      }
      else if(giXIndex==1 && giYIndex==-1)
      {
         Image3->Left=Image2->Left-Image1->Width;
         Image3->Top=Image2->Top;
         Image4->Left=Image2->Left;
         Image4->Top=Image2->Top+Image1->Height;
         Image5->Left=Image2->Left-Image1->Width;
         Image5->Top=Image2->Top+Image1->Height;
      }
      else if(giXIndex==1 && giYIndex==1)
      {
         Image3->Left=Image2->Left-Image1->Width;
         Image3->Top=Image2->Top;
         Image4->Left=Image2->Left;
         Image4->Top=Image2->Top-Image1->Height;
         Image5->Left=Image2->Left-Image1->Width;
         Image5->Top=Image2->Top-Image1->Height;
      }
      else if(giXIndex==-1 && giYIndex==1)
      {
         Image3->Left=Image2->Left+Image1->Width;
         Image3->Top=Image2->Top;
         Image4->Left=Image2->Left;
         Image4->Top=Image2->Top-Image1->Height;
         Image5->Left=Image2->Left+Image1->Width;
         Image5->Top=Image2->Top-Image1->Height;
      }
      else
      {
         Image3->Left=0;
         Image3->Top=0;
         Image4->Left=0;
         Image4->Top=0;
         Image5->Left=0;
         Image5->Top=0;
      }
   }

   TRect rtImage1=Rect(Image1->Left, Image1->Top, Image1->Left+Image1->Width, Image1->Top+Image1->Height);
   TRect rtImage2=Rect(Image2->Left, Image2->Top, Image2->Left+Image2->Width, Image2->Top+Image2->Height);
   TRect rtImage3=Rect(Image3->Left, Image3->Top, Image3->Left+Image3->Width, Image3->Top+Image3->Height);
   TRect rtImage4=Rect(Image4->Left, Image4->Top, Image4->Left+Image4->Width, Image4->Top+Image4->Height);
   TRect rtImage5=Rect(Image5->Left, Image5->Top, Image5->Left+Image5->Width, Image5->Top+Image5->Height);
   TRect rtImage12;
   TRect rtImage13;
   TRect rtImage14;
   TRect rtImage15;
   TRect rtImg2;
   TRect rtImg3;
   TRect rtImg4;
   TRect rtImg5;

   if(IntersectRect(rtImage12, rtImage1, rtImage2))
   {
      Image2->Canvas->FillRect(Rect(0, 0, Image2->Width, Image2->Height));
      if(giXIndex==-1)
      {
         rtImg2.Left=Image2->Width-rtImage12.Right+rtImage12.Left;
         rtImg2.Right=Image2->Width;
      }
      else if(giXIndex==1)
      {
         rtImg2.Left=0;
         rtImg2.Right=rtImage12.Right-rtImage12.Left;
      }
      else if(giXIndex==0)
      {
         rtImg2.Left=0;
         rtImg2.Right=Image2->Width;
      }

      if(giYIndex==-1)
      {
         rtImg2.Top=Image2->Height-rtImage12.Bottom+rtImage12.Top;
         rtImg2.Bottom=Image2->Height;
      }
      else if(giYIndex==1)
      {
         rtImg2.Top=0;
         rtImg2.Bottom=rtImage12.Bottom-rtImage12.Top;
      }
      else if(giYIndex==0)
      {
         rtImg2.Top=0;
         rtImg2.Bottom=Image2->Height;
      }
      Image2->Canvas->CopyRect(rtImg2, bmp2->Canvas, rtImg2);
   }
   else
   {
      Image2->Canvas->CopyRect(Rect(0, 0, Image2->Width, Image2->Height),
         bmp2->Canvas, Rect(0, 0, bmp2->Width, bmp2->Height));
   }

   if(IntersectRect(rtImage13, rtImage1, rtImage3))
   {
      Image3->Canvas->FillRect(Rect(0, 0, Image3->Width, Image3->Height));
      if(giXIndex==-1)
      {
         rtImg3.Left=0;
         rtImg3.Right=rtImage13.Right-rtImage13.Left;
      }
      else if(giXIndex==1)
      {
         rtImg3.Left=Image3->Width-rtImage13.Right+rtImage13.Left;
         rtImg3.Right=Image3->Width;
      }
      else if(giXIndex==0)
      {
         rtImg3.Left=0;
         rtImg3.Right=Image3->Width;
      }

      if(giYIndex==-1)
      {
         rtImg3.Top=Image3->Height-rtImage13.Bottom+rtImage13.Top;
         rtImg3.Bottom=Image3->Height;
      }
      else if(giYIndex==1)
      {
         rtImg3.Top=0;
         rtImg3.Bottom=rtImage13.Bottom-rtImage13.Top;
      }
      else if(giYIndex==0)
      {
         rtImg3.Top=0;
         rtImg3.Bottom=Image3->Height;
      }
      Image3->Canvas->CopyRect(rtImg3, bmp2->Canvas, rtImg3);
   }
   else
   {
      Image3->Canvas->FillRect(Rect(0, 0, Image3->Width, Image3->Height));
   }

   if(IntersectRect(rtImage14, rtImage1, rtImage4))
   {
      Image4->Canvas->FillRect(Rect(0, 0, Image4->Width, Image4->Height));
      if(giXIndex==-1)
      {
         rtImg4.Left=rtImage14.Left-Image4->Left;
         rtImg4.Right=Image4->Width;
      }
      else if(giXIndex==1)
      {
         rtImg4.Left=0;
         rtImg4.Right=rtImage14.Right-rtImage14.Left;
      }
      else if(giXIndex==0)
      {
         rtImg4.Left=0;
         rtImg4.Right=Image4->Width;
      }

      if(giYIndex==-1)
      {
         rtImg4.Top=0;
         rtImg4.Bottom=rtImage14.Bottom-rtImage14.Top;
      }
      else if(giYIndex==1)
      {
         rtImg4.Top=Image4->Height-rtImage14.Bottom+rtImage14.Top;
         rtImg4.Bottom=Image4->Height;
      }
      else if(giYIndex==0)
      {
         rtImg4.Top=0;
         rtImg4.Bottom=Image4->Height;
      }
      Image4->Canvas->CopyRect(rtImg4, bmp2->Canvas, rtImg4);
   }
   else
   {
      Image4->Canvas->FillRect(Rect(0, 0, Image4->Width, Image4->Height));
   }

   if(IntersectRect(rtImage15, rtImage1, rtImage5))
   {
      Image5->Canvas->FillRect(Rect(0, 0, Image5->Width, Image5->Height));
      if(giXIndex==-1)
      {
         rtImg5.Left=0;
         rtImg5.Right=rtImage15.Right-rtImage15.Left;
      }
      else if(giXIndex==1)
      {
         rtImg5.Left=Image5->Width-rtImage15.Right+rtImage15.Left;
         rtImg5.Right=Image5->Width;
      }
      else
      {
         //
      }

      if(giYIndex==-1)
      {
         rtImg5.Top=0;
         rtImg5.Bottom=rtImage15.Bottom-rtImage15.Top;
      }
      else if(giYIndex==1)
      {
         rtImg5.Top=Image5->Height-rtImage15.Bottom+rtImage15.Top;
         rtImg5.Bottom=Image5->Height;
      }
      else
      {
         //
      }
      Image5->Canvas->CopyRect(rtImg5, bmp2->Canvas, rtImg5);
   }
   else
   {
      Image5->Canvas->FillRect(Rect(0, 0, Image5->Width, Image5->Height));
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image2MouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
   gbCanMove=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   HDC dc;
   dc=GetDC(GetDesktopWindow());
   TCanvas *canvas=new TCanvas;
   canvas->Handle=dc;
   Graphics::TBitmap *bmp=new Graphics::TBitmap;
   bmp->Width=Image1->Width;
   bmp->Height=Image1->Height;
   bmp->Canvas->CopyMode=cmSrcCopy;
   SetStretchBltMode(bmp->Canvas->Handle, STRETCH_HALFTONE);
   TPoint ptLT, ptRB;
   ptLT.x=Image1->Left;
   ptLT.y=Image1->Top;
   ptRB.x=Image1->Left+Image1->Width;
   ptRB.y=Image1->Top+Image1->Height;
   ptLT=Form1->ClientToScreen(ptLT);
   ptRB=Form1->ClientToScreen(ptRB);
   bmp->Canvas->CopyRect(Rect(0, 0, bmp->Width, bmp->Height),
      canvas, Rect(ptLT.x, ptLT.y, ptRB.x, ptRB.y));
   bmp->SaveToFile("merge.bmp");
   delete bmp;
   delete canvas;
   ReleaseDC(NULL, dc);
}
//---------------------------------------------------------------------------

